Items
Manage conversations and conversation items.
Create items
POST
/conversations/{conversation_id}/itemsDelete an item
DELETE
/conversations/{conversation_id}/items/{item_id}List items
GET
/conversations/{conversation_id}/itemsRetrieve an item
GET
/conversations/{conversation_id}/items/{item_id}Models
ConversationItem = Message { id, content, role, 3 more } or FunctionCall { id, arguments, call_id, 7 more } or FunctionCallOutput { id, output, status, 6 more } or 26 moreA single item within a conversation. The set of possible types are the same as the output type of a Response object.
ConversationItem = Message { id, content, role, 3 more } or FunctionCall { id, arguments, call_id, 7 more } or FunctionCallOutput { id, output, status, 6 more } or 26 more
A single item within a conversation. The set of possible types are the same as the output type of a Response object.
One of the following: Message { id, content, role, 3 more } A message to or from the model. id: string The unique ID of the message. content: array of ResponseInputText or ResponseOutputText or TextContent or 6 more The content of the message One of the following: ResponseInputText { text, type, prompt_cache_breakpoint } A text input to the model. text: string The text input to the model. type: "input_text" (default: "input_text") The type of the input item. Always input_text. prompt_cache_breakpoint: optional { mode, ttl } Marks the exact end of a reusable prompt prefix. When ttl is omitted, the breakpoint inherits the request’s prompt_cache_options.ttl; the boundary is not rounded to a token block. mode: "explicit" (default: "explicit") The breakpoint mode. Always explicit. ttl: optional "30m" or "12h" The minimum lifetime of this cache breakpoint. Defaults to the request TTL. One of the following: "30m" "12h" ResponseOutputText { annotations, logprobs, text, type } A text output from the model. annotations: array of FileCitation or URLCitation or ContainerFileCitation or FilePath The annotations of the text output. One of the following: FileCitation { file_id, filename, index, type } A citation to a file. file_id: string The ID of the file. filename: string The filename of the file cited. index: integer The index in the output text at which to insert the file citation. type: "file_citation" (default: "file_citation") The type of the file citation. Always file_citation. URLCitation { end_index, start_index, title, 2 more } A citation for a web resource used to generate a model response. end_index: integer The index of the last character of the URL citation in the message. start_index: integer The index of the first character of the URL citation in the message. title: string The title of the web resource. type: "url_citation" (default: "url_citation") The type of the URL citation. Always url_citation. url: string The URL of the web resource. formaturi ContainerFileCitation { container_id, end_index, file_id, 3 more } A citation for a container file used to generate a model response. container_id: string The ID of the container file. end_index: integer The index of the last character of the container file citation in the message. file_id: string The ID of the file. filename: string The filename of the container file cited. start_index: integer The index of the first character of the container file citation in the message. type: "container_file_citation" (default: "container_file_citation") The type of the container file citation. Always container_file_citation. FilePath { file_id, index, type } A path to a file. file_id: string The ID of the file. index: integer The index of the file in the list of files. type: "file_path" The type of the file path. Always file_path. logprobs: array of { token, bytes, logprob, top_logprobs } token: string bytes: array of number logprob: number top_logprobs: array of { token, bytes, logprob } token: string bytes: array of number logprob: number text: string The text output from the model. type: "output_text" (default: "output_text") The type of the output text. Always output_text. TextContent { text, type } A text content. text: string type: "text" (default: "text") SummaryTextContent { text, type } A summary text from the model. text: string A summary of the reasoning output from the model so far. type: "summary_text" (default: "summary_text") The type of the object. Always summary_text. ReasoningText { text, type } Reasoning text from the model. text: string The reasoning text from the model. type: "reasoning_text" (default: "reasoning_text") The type of the reasoning text. Always reasoning_text. ResponseOutputRefusal { refusal, type } A refusal from the model. refusal: string The refusal explanation from the model. type: "refusal" (default: "refusal") The type of the refusal. Always refusal. ResponseInputImage { detail, type, file_id, 2 more } An image input to the model. Learn about image inputs. detail: ImageDetail The detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto. type: "input_image" (default: "input_image") The type of the input item. Always input_image. file_id: optional string or null The ID of the file to be sent to the model. image_url: optional string or null The URL of the image to be sent to the model. A fully qualified URL or base64 encoded image in a data URL. formaturi prompt_cache_breakpoint: optional { mode, ttl } Marks the exact end of a reusable prompt prefix. When ttl is omitted, the breakpoint inherits the request’s prompt_cache_options.ttl; the boundary is not rounded to a token block. mode: "explicit" (default: "explicit") The breakpoint mode. Always explicit. ttl: optional "30m" or "12h" The minimum lifetime of this cache breakpoint. Defaults to the request TTL. One of the following: "30m" "12h" ComputerScreenshotContent { detail, file_id, image_url, 2 more } A screenshot of a computer. detail: ImageDetail The detail level of the screenshot image to be sent to the model. One of high, low, auto, or original. Defaults to auto. file_id: string or null The identifier of an uploaded file that contains the screenshot. image_url: string or null The URL of the screenshot image. formaturi type: "computer_screenshot" (default: "computer_screenshot") Specifies the event type. For a computer screenshot, this property is always set to computer_screenshot. prompt_cache_breakpoint: optional { mode, ttl } Marks the exact end of a reusable prompt prefix. When ttl is omitted, the breakpoint inherits the request’s prompt_cache_options.ttl; the boundary is not rounded to a token block. mode: "explicit" (default: "explicit") The breakpoint mode. Always explicit. ttl: optional "30m" or "12h" The minimum lifetime of this cache breakpoint. Defaults to the request TTL. One of the following: "30m" "12h" ResponseInputFile { type, detail, file_data, 4 more } A file input to the model. type: "input_file" (default: "input_file") The type of the input item. Always input_file. detail: optional "auto" or "low" or "high" The detail level of the file to be sent to the model. Use auto to let the system select the detail level; for GPT-5.6 and later models, auto uses high-quality rendering, which may increase input token usage. Use low for lower-cost rendering, or high to render the file at higher quality. Defaults to auto. One of the following: "auto" "low" "high" file_data: optional string The content of the file to be sent to the model. file_id: optional string or null The ID of the file to be sent to the model. file_url: optional string The URL of the file to be sent to the model. formaturi filename: optional string The name of the file to be sent to the model. prompt_cache_breakpoint: optional { mode, ttl } Marks the exact end of a reusable prompt prefix. When ttl is omitted, the breakpoint inherits the request’s prompt_cache_options.ttl; the boundary is not rounded to a token block. mode: "explicit" (default: "explicit") The breakpoint mode. Always explicit. ttl: optional "30m" or "12h" The minimum lifetime of this cache breakpoint. Defaults to the request TTL. One of the following: "30m" "12h" role: "unknown" or "user" or "assistant" or 5 more The role of the message. One of unknown, user, assistant, system, critic, discriminator, developer, or tool. One of the following: "unknown" "user" "assistant" "system" "critic" "discriminator" "developer" "tool" status: "in_progress" or "completed" or "incomplete" The status of item. One of in_progress, completed, or incomplete. Populated when items are returned via API. One of the following: "in_progress" "completed" "incomplete" type: "message" (default: "message") The type of the message. Always set to message. phase: optional "commentary" or "final_answer" or null Labels an assistant message as intermediate commentary (commentary) or the final answer (final_answer). For models like gpt-5.3-codex and beyond, when sending follow-up requests, preserve and resend phase on all assistant messages — dropping it can degrade performance. Not used for user messages. One of the following: "commentary" "final_answer" FunctionCall { id, arguments, call_id, 7 more } id: string The unique ID of the function tool call. arguments: string A JSON string of the arguments to pass to the function. call_id: string The unique ID of the function tool call generated by the model. name: string The name of the function to run. status: "in_progress" or "completed" or "incomplete" The status of the item. One of in_progress, completed, or incomplete. Populated when items are returned via API. One of the following: "in_progress" "completed" "incomplete" type: "function_call" The type of the function tool call. Always function_call. async: optional boolean Whether the function tool call runs asynchronously. caller: optional Direct or Program or null The execution context that produced this tool call. One of the following: Direct { type } type: "direct" (default: "direct") Program { caller_id, type } caller_id: string The call ID of the program item that produced this tool call. type: "program" (default: "program") created_by: optional string The identifier of the actor that created the item. namespace: optional string The namespace of the function to run. FunctionCallOutput { id, output, status, 6 more } id: string The unique ID of the function call tool output. output: string or array of ResponseInputText or ResponseInputImage or ResponseInputFile The output from the function call generated by your code. Can be a string or an list of output content. One of the following: StringOutput = string A string of the output of the function call. OutputContentList = array of ResponseInputText or ResponseInputImage or ResponseInputFile Text, image, or file output of the function call. One of the following: ResponseInputText { text, type, prompt_cache_breakpoint } A text input to the model. text: string The text input to the model. type: "input_text" (default: "input_text") The type of the input item. Always input_text. prompt_cache_breakpoint: optional { mode, ttl } Marks the exact end of a reusable prompt prefix. When ttl is omitted, the breakpoint inherits the request’s prompt_cache_options.ttl; the boundary is not rounded to a token block. mode: "explicit" (default: "explicit") The breakpoint mode. Always explicit. ttl: optional "30m" or "12h" The minimum lifetime of this cache breakpoint. Defaults to the request TTL. One of the following: "30m" "12h" ResponseInputImage { detail, type, file_id, 2 more } An image input to the model. Learn about image inputs. detail: ImageDetail The detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto. type: "input_image" (default: "input_image") The type of the input item. Always input_image. file_id: optional string or null The ID of the file to be sent to the model. image_url: optional string or null The URL of the image to be sent to the model. A fully qualified URL or base64 encoded image in a data URL. formaturi prompt_cache_breakpoint: optional { mode, ttl } Marks the exact end of a reusable prompt prefix. When ttl is omitted, the breakpoint inherits the request’s prompt_cache_options.ttl; the boundary is not rounded to a token block. mode: "explicit" (default: "explicit") The breakpoint mode. Always explicit. ttl: optional "30m" or "12h" The minimum lifetime of this cache breakpoint. Defaults to the request TTL. One of the following: "30m" "12h" ResponseInputFile { type, detail, file_data, 4 more } A file input to the model. type: "input_file" (default: "input_file") The type of the input item. Always input_file. detail: optional "auto" or "low" or "high" The detail level of the file to be sent to the model. Use auto to let the system select the detail level; for GPT-5.6 and later models, auto uses high-quality rendering, which may increase input token usage. Use low for lower-cost rendering, or high to render the file at higher quality. Defaults to auto. One of the following: "auto" "low" "high" file_data: optional string The content of the file to be sent to the model. file_id: optional string or null The ID of the file to be sent to the model. file_url: optional string The URL of the file to be sent to the model. formaturi filename: optional string The name of the file to be sent to the model. prompt_cache_breakpoint: optional { mode, ttl } Marks the exact end of a reusable prompt prefix. When ttl is omitted, the breakpoint inherits the request’s prompt_cache_options.ttl; the boundary is not rounded to a token block. mode: "explicit" (default: "explicit") The breakpoint mode. Always explicit. ttl: optional "30m" or "12h" The minimum lifetime of this cache breakpoint. Defaults to the request TTL. One of the following: "30m" "12h" status: "in_progress" or "completed" or "incomplete" The status of the item. One of in_progress, completed, or incomplete. Populated when items are returned via API. One of the following: "in_progress" "completed" "incomplete" type: "function_call_output" The type of the function tool call output. Always function_call_output. call_id: optional string The unique ID of the function tool call generated by the model. caller: optional Direct or Program or null The execution context that produced this tool call. One of the following: Direct { type } type: "direct" (default: "direct") The caller type. Always direct. Program { caller_id, type } caller_id: string The call ID of the program item that produced this tool call. minLength1 maxLength64 type: "program" (default: "program") The caller type. Always program. created_by: optional string The identifier of the actor that created the item. name: optional string The name of the tool that produced the output. namespace: optional string The namespace of the tool that produced the output. FileSearchCall { id, queries, status, 2 more } The results of a file search tool call. See the file search guide for more information. id: string The unique ID of the file search tool call. queries: array of string The queries used to search for files. status: "in_progress" or "searching" or "completed" or 2 more The status of the file search tool call. One of in_progress, searching, incomplete or failed, One of the following: "in_progress" "searching" "completed" "incomplete" "failed" type: "file_search_call" The type of the file search tool call. Always file_search_call. results: optional array of object or null The results of the file search tool call. attributes: optional map[string or number or boolean] or null Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters, booleans, or numbers. One of the following: string maxLength512 number boolean file_id: optional string The unique ID of the file. filename: optional string The name of the file. score: optional number The relevance score of the file - a value between 0 and 1. formatfloat text: optional string The text that was retrieved from the file. WebSearchCall { id, status, type, action } The results of a web search tool call. See the web search guide for more information. id: string The unique ID of the web search tool call. status: "in_progress" or "searching" or "completed" or 2 more The status of the web search tool call. One of the following: "in_progress" "searching" "completed" "failed" "incomplete" type: "web_search_call" The type of the web search tool call. Always web_search_call. action: optional Search or OpenPage or FindInPage An object describing the specific action taken in this web search call. Includes details on how the model used the web (search, open_page, find_in_page). One of the following: Search { type, queries, query, sources } Action type “search” - Performs a web search query. type: "search" The action type. queries: optional array of string The search queries. query: optional string Deprecated. The search query. sources: optional array of { type, url } The sources used in the search. type: "url" The type of source. Always url. url: string The URL of the source. formaturi OpenPage { type, url } Action type “open_page” - Opens a specific URL from search results. type: "open_page" The action type. url: optional string or null The URL opened by the model. formaturi FindInPage { pattern, type, url } Action type “find_in_page”: Searches for a pattern within a loaded page. pattern: string The pattern or text to search for within the page. type: "find_in_page" The action type. url: optional string or null The URL of the page searched for the pattern, when available. formaturi ImageGenerationCall { id, result, status, 9 more } An image generation request made by the model. id: string The unique ID of the image generation call. result: string or null The generated image encoded in base64. status: "in_progress" or "completed" or "generating" or "failed" The status of the image generation call. One of the following: "in_progress" "completed" "generating" "failed" type: "image_generation_call" The type of the image generation call. Always image_generation_call. action: optional "generate" or "edit" or "auto" or null The action used for image generation. One of the following: "generate" "edit" "auto" background: optional "transparent" or "opaque" or "auto" or null The background setting used for generation. One of the following: "transparent" "opaque" "auto" error: optional { code, message, param, 2 more } Details of a moderation failure, when available. code: string or null The error code. message: string A description of the error. param: string or null The related request parameter. type: string The error type. moderation_details: optional { categories, moderation_stage } Public details for a moderation_blocked error, when available. categories: array of string Public moderation categories. New category values may be added over time. moderation_stage: "input" or "output" or "unknown" The stage where moderation blocked the image generation call. One of the following: "input" "output" "unknown" output_format: optional "png" or "webp" or "jpeg" or 2 more or null The output format used for generation. One of the following: "png" "webp" "jpeg" "gif" "svg" quality: optional "low" or "medium" or "high" or 3 more or null The quality of the image generated by the image generation tool call. One of low, medium, high, xhigh, max, or auto. One of the following: "low" "medium" "high" "xhigh" "max" "auto" revised_prompt: optional string or null The prompt that was used after any model prompt rewriting. size: optional string or "1024x1024" or "1024x1536" or "1536x1024" or null The image dimensions as a WIDTHxHEIGHT string, for example 1536x864. One of the following: string "1024x1024" or "1024x1536" or "1536x1024" The image dimensions as a WIDTHxHEIGHT string, for example 1536x864. One of the following: "1024x1024" "1024x1536" "1536x1024" svg_usage: optional { input_tokens, model, output_tokens, 2 more } input_tokens: integer model: string output_tokens: integer reasoning_tokens: integer total_tokens: integer ComputerCall { id, call_id, pending_safety_checks, 4 more } A tool call to a computer use tool. See the computer use guide for more information. id: string The unique ID of the computer call. call_id: string An identifier used when responding to the tool call with output. pending_safety_checks: array of { id, code, message } The pending safety checks for the computer call. id: string The ID of the pending safety check. code: optional string or null The type of the pending safety check. message: optional string or null Details about the pending safety check. status: "in_progress" or "completed" or "incomplete" The status of the item. One of in_progress, completed, or incomplete. Populated when items are returned via API. One of the following: "in_progress" "completed" "incomplete" type: "computer_call" (default: "computer_call") The type of the computer call. Always computer_call. action: optional ComputerAction A click action. actions: optional ComputerActionList { Click, DoubleClick, Drag, 6 more } Flattened batched actions for computer_use. Each action includes an type discriminator and action-specific fields. ComputerCallOutput { id, call_id, output, 4 more } id: string The ID of the computer tool call output. call_id: string The ID of the computer tool call that produced the output. output: ResponseComputerToolCallOutputScreenshot { type, file_id, image_url } A computer screenshot image used with the computer use tool. status: "completed" or "incomplete" or "failed" or "in_progress" The status of the message input. One of in_progress, completed, or incomplete. Populated when input items are returned via API. One of the following: "completed" "incomplete" "failed" "in_progress" type: "computer_call_output" (default: "computer_call_output") The type of the computer tool call output. Always computer_call_output. acknowledged_safety_checks: optional array of { id, code, message } The safety checks reported by the API that have been acknowledged by the developer. id: string The ID of the pending safety check. code: optional string or null The type of the pending safety check. message: optional string or null Details about the pending safety check. created_by: optional string The identifier of the actor that created the item. ToolSearchCall { id, arguments, call_id, 4 more } id: string The unique ID of the tool search call item. arguments: unknown Arguments used for the tool search call. call_id: string or null The unique ID of the tool search call generated by the model. execution: "server" or "client" Whether tool search was executed by the server or by the client. One of the following: "server" "client" status: "in_progress" or "completed" or "incomplete" The status of the tool search call item that was recorded. One of the following: "in_progress" "completed" "incomplete" type: "tool_search_call" (default: "tool_search_call") The type of the item. Always tool_search_call. created_by: optional string The identifier of the actor that created the item. ToolSearchOutput { id, call_id, execution, 4 more } id: string The unique ID of the tool search output item. call_id: string or null The unique ID of the tool search call generated by the model. execution: "server" or "client" Whether tool search was executed by the server or by the client. One of the following: "server" "client" status: "in_progress" or "completed" or "incomplete" The status of the tool search output item that was recorded. One of the following: "in_progress" "completed" "incomplete" tools: array of Function or FileSearch or Computer or 13 more The loaded tool definitions returned by tool search. One of the following: Function { name, parameters, strict, 6 more } Defines a function in your own code the model can choose to call. Learn more about function calling. name: string The name of the function to call. parameters: map[unknown] or null A JSON schema object describing the parameters of the function. strict: boolean or null Whether strict parameter validation is enforced for this function tool. type: "function" (default: "function") The type of the function tool. Always function. allowed_callers: optional array of "direct" or "programmatic" or null The tool invocation context(s). One of the following: "direct" "programmatic" async: optional boolean defer_loading: optional boolean Whether this function is deferred and loaded via tool search. description: optional string or null A description of the function. Used by the model to determine whether or not to call the function. output_schema: optional map[unknown] or null A JSON schema object describing the JSON value encoded in string outputs for this function. FileSearch { type, vector_store_ids, filters, 2 more } A tool that searches for relevant content from uploaded files. Learn more about the file search tool. type: "file_search" (default: "file_search") The type of the file search tool. Always file_search. vector_store_ids: array of string The IDs of the vector stores to search. filters: optional ComparisonFilter or CompoundFilter or null A filter to apply. One of the following: ComparisonFilter { key, type, value } A filter used to compare a specified attribute key to a given value using a defined comparison operation. key: string The key to compare against the value. type: "eq" or "ne" or "gt" or 5 more (default: "eq") Specifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin. eq: equals ne: not equal gt: greater than gte: greater than or equal lt: less than lte: less than or equal in: in nin: not in One of the following: "eq" "ne" "gt" "gte" "lt" "lte" "in" "nin" value: string or number or boolean or array of string or number The value to compare against the attribute key; supports string, number, or boolean types. One of the following: string number boolean array of string or number One of the following: string number CompoundFilter { filters, type } Combine multiple filters using and or or. filters: array of ComparisonFilter or CompoundFilter Array of filters to combine. Items can be ComparisonFilter or CompoundFilter. One of the following: ComparisonFilter { key, type, value } A filter used to compare a specified attribute key to a given value using a defined comparison operation. key: string The key to compare against the value. type: "eq" or "ne" or "gt" or 5 more (default: "eq") Specifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin. eq: equals ne: not equal gt: greater than gte: greater than or equal lt: less than lte: less than or equal in: in nin: not in One of the following: "eq" "ne" "gt" "gte" "lt" "lte" "in" "nin" value: string or number or boolean or array of string or number The value to compare against the attribute key; supports string, number, or boolean types. One of the following: string number boolean array of string or number One of the following: string number CompoundFilter { filters, type } This type repeats the enclosing schema. type: "and" or "or" Type of operation: and or or. One of the following: "and" "or" max_num_results: optional integer The maximum number of results to return. This number should be between 1 and 50 inclusive. ranking_options: optional { hybrid_search, ranker, score_threshold } Ranking options for search. hybrid_search: optional { embedding_weight, text_weight } Weights that control how reciprocal rank fusion balances semantic embedding matches versus sparse keyword matches when hybrid search is enabled. embedding_weight: number The weight of the embedding in the reciprocal ranking fusion. text_weight: number The weight of the text in the reciprocal ranking fusion. ranker: optional "auto" or "default-2024-11-15" The ranker to use for the file search. One of the following: "auto" "default-2024-11-15" score_threshold: optional number The score threshold for the file search, a number between 0 and 1. Numbers closer to 1 will attempt to return only the most relevant results, but may return fewer results. Computer { type } A tool that controls a virtual computer. Learn more about the computer tool. type: "computer" (default: "computer") The type of the computer tool. Always computer. ComputerUsePreview { display_height, display_width, environment, type } A tool that controls a virtual computer. Learn more about the computer tool. display_height: integer The height of the computer display. display_width: integer The width of the computer display. environment: "windows" or "mac" or "linux" or 2 more The type of computer environment to control. One of the following: "windows" "mac" "linux" "ubuntu" "browser" type: "computer_use_preview" (default: "computer_use_preview") The type of the computer use tool. Always computer_use_preview. WebSearch { type, external_web_access, filters, 2 more } Search the Internet for sources related to the prompt. Learn more about the web search tool. type: "web_search" or "web_search_2025_08_26" (default: "web_search") The type of the web search tool. One of web_search or web_search_2025_08_26. One of the following: "web_search" "web_search_2025_08_26" external_web_access: optional boolean (default: true) Allow live internet access for web search. Defaults to true when omitted. When false, the web search tool runs in offline/cache-only mode and will not fetch new external content. filters: optional object or null Filters for the search. allowed_domains: optional array of string or null (default: []) Allowed domains for the search. If not provided, all domains are allowed. Subdomains of the provided domains are allowed as well. Example: ["pubmed.ncbi.nlm.nih.gov"] search_context_size: optional "low" or "medium" or "high" (default: "medium") High level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default. One of the following: "low" "medium" "high" user_location: optional object or null The approximate location of the user. If omitted or null, defaults to the United States. To avoid this fallback, pass {"type": "approximate"} without location fields. To localize results, provide the relevant location fields. city: optional string or null Free text input for the city of the user, e.g. San Francisco. country: optional string or null The two-letter ISO country code of the user, e.g. US. region: optional string or null Free text input for the region of the user, e.g. California. timezone: optional string or null The IANA timezone of the user, e.g. America/Los_Angeles. type: optional "approximate" (default: "approximate") The type of location approximation. Always approximate. Mcp { server_label, type, allowed_callers, 9 more } Give the model access to additional tools via remote Model Context Protocol (MCP) servers. Learn more about MCP. server_label: string A label for this MCP server, used to identify it in tool calls. type: "mcp" The type of the MCP tool. Always mcp. allowed_callers: optional array of "direct" or "programmatic" or null The tool invocation context(s). minItems1 One of the following: "direct" "programmatic" allowed_tools: optional array of string or McpToolFilter or null List of allowed tool names or a filter object. One of the following: McpAllowedTools = array of string A string array of allowed tool names McpToolFilter { read_only, tool_names } A filter object to specify which tools are allowed. read_only: optional boolean Indicates whether or not a tool modifies data or is read-only. If an MCP server is annotated with readOnlyHint, it will match this filter. tool_names: optional array of string List of allowed tool names. authorization: optional string An OAuth access token that can be used with a remote MCP server, either with a custom MCP server URL or a service connector. Your application must handle the OAuth authorization flow and provide the token here. connector_id: optional "connector_dropbox" or "connector_gmail" or "connector_googlecalendar" or 5 more Deprecated. Identifier for service connectors, like those available in ChatGPT. One of server_url, connector_id, or tunnel_id must be provided. Learn more about service connectors here. This field is deprecated for models released after September 1, 2026. Use server_url to connect to a remote MCP server, or tunnel_id to connect through a Secure MCP Tunnel. Currently supported connector_id values are: Dropbox: connector_dropbox Gmail: connector_gmail Google Calendar: connector_googlecalendar Google Drive: connector_googledrive Microsoft Teams: connector_microsoftteams Outlook Calendar: connector_outlookcalendar Outlook Email: connector_outlookemail SharePoint: connector_sharepoint One of the following: "connector_dropbox" "connector_gmail" "connector_googlecalendar" "connector_googledrive" "connector_microsoftteams" "connector_outlookcalendar" "connector_outlookemail" "connector_sharepoint" defer_loading: optional boolean Whether this MCP tool is deferred and discovered via tool search. headers: optional map[string] or null Optional HTTP headers to send to the MCP server. Use for authentication or other purposes. require_approval: optional McpToolApprovalFilter or "always" or "never" or null (default: "always") Specify which of the MCP server’s tools require approval. One of the following: McpToolApprovalFilter { always, never } Specify which of the MCP server’s tools require approval. Can be always, never, or a filter object associated with tools that require approval. always: optional { read_only, tool_names } A filter object to specify which tools are allowed. read_only: optional boolean Indicates whether or not a tool modifies data or is read-only. If an MCP server is annotated with readOnlyHint, it will match this filter. tool_names: optional array of string List of allowed tool names. never: optional { read_only, tool_names } A filter object to specify which tools are allowed. read_only: optional boolean Indicates whether or not a tool modifies data or is read-only. If an MCP server is annotated with readOnlyHint, it will match this filter. tool_names: optional array of string List of allowed tool names. McpToolApprovalSetting = "always" or "never" Specify a single approval policy for all tools. One of always or never. When set to always, all tools will require approval. When set to never, all tools will not require approval. One of the following: "always" "never" server_description: optional string Optional description of the MCP server, used to provide more context. server_url: optional string The URL for the MCP server. One of server_url, connector_id, or tunnel_id must be provided. formaturi tunnel_id: optional string The Secure MCP Tunnel ID to use instead of a direct server URL. One of server_url, connector_id, or tunnel_id must be provided. pattern^tunnel_[a-z0-9]{32}$ CodeInterpreter { container, type, allowed_callers } A tool that runs Python code to help generate a response to a prompt. container: string or CodeInterpreterToolAuto The code interpreter container. Can be a container ID or an object that specifies uploaded file IDs to make available to your code, along with an optional memory_limit setting. One of the following: string The container ID. CodeInterpreterToolAuto { type, file_ids, memory_limit, network_policy } Configuration for a code interpreter container. Optionally specify the IDs of the files to run the code on. type: "auto" (default: "auto") Always auto. file_ids: optional array of string An optional list of uploaded files to make available to your code. maxItems50 memory_limit: optional "1g" or "4g" or "16g" or "64g" or null The memory limit for the code interpreter container. One of the following: "1g" "4g" "16g" "64g" network_policy: optional ContainerNetworkPolicyDisabled or ContainerNetworkPolicyAllowlist Network access policy for the container. One of the following: ContainerNetworkPolicyDisabled { type } type: "disabled" (default: "disabled") Disable outbound network access. Always disabled. ContainerNetworkPolicyAllowlist { allowed_domains, type, domain_secrets } allowed_domains: array of string A list of allowed domains when type is allowlist. minItems1 type: "allowlist" (default: "allowlist") Allow outbound network access only to specified domains. Always allowlist. domain_secrets: optional array of ContainerNetworkPolicyDomainSecret { domain, name, value } Optional domain-scoped secrets for allowlisted domains. minItems1 domain: string The domain associated with the secret. minLength1 name: string The name of the secret to inject for the domain. minLength1 value: string The secret value to inject for the domain. minLength1 maxLength10485760 type: "code_interpreter" The type of the code interpreter tool. Always code_interpreter. allowed_callers: optional array of "direct" or "programmatic" or null The tool invocation context(s). minItems1 One of the following: "direct" "programmatic" ProgrammaticToolCalling { type } type: "programmatic_tool_calling" (default: "programmatic_tool_calling") The type of the tool. Always programmatic_tool_calling. ImageGeneration { type, action, background, 13 more } A tool that generates images using the GPT image models. type: "image_generation" The type of the image generation tool. Always image_generation. action: optional "generate" or "edit" or "auto" Whether to generate a new image or edit an existing image. Default: auto. One of the following: "generate" "edit" "auto" background: optional "transparent" or "opaque" or "auto" (default: "auto") Set the background of the generated image. One of transparent, opaque, or auto. gpt-image-2.5-sunburst and gpt-image-2.5-flare, including their 2026-09-08 snapshots, support opaque and transparent backgrounds. Transparent backgrounds are available for supported GPT Image models. For gpt-image-2 and gpt-image-2-2026-04-21, this support is in preview. When using transparent, set the output format to png or webp. Default: auto. One of the following: "transparent" "opaque" "auto" complexity: optional "low" or "medium" or "high" Computation spent planning the image, independently of rendering quality. Overrides the outer response’s reasoning.effort for image generation. When omitted, inherits a supported outer reasoning effort or uses the image model’s configured default. For SVG output, controls the reference image, not the SVG author’s reasoning. One of the following: "low" "medium" "high" frame_count: optional integer (default: 9) Number of GIF frames. Requires output_format to be gif. Default: 9. minimum2 maximum16 frame_duration_ms: optional integer (default: 200) Duration of each GIF frame in milliseconds, rounded to 10 ms. Requires output_format to be gif. Default: 200. minimum20 maximum2000 input_fidelity: optional "high" or "low" or null Control how much effort the model will exert to match the style and features, especially facial features, of input images. Supports high and low on gpt-image-1.5; gpt-image-1-mini supports only low. For gpt-image-2, omit this parameter. Defaults to low on supported models. One of the following: "high" "low" input_image_mask: optional { file_id, image_url } Optional mask for inpainting. Contains image_url (string, optional) and file_id (string, optional). file_id: optional string File ID for the mask image. image_url: optional string Base64-encoded mask image. model: optional string or "gpt-image-1" or "gpt-image-1-mini" or "gpt-image-2" or 9 more The image generation model to use. One of gpt-image-1-mini, gpt-image-1.5, gpt-image-2, gpt-image-2-2026-04-21, gpt-image-2.5-sunburst, gpt-image-2.5-sunburst-2026-09-08, gpt-image-2.5-flare, gpt-image-2.5-flare-2026-09-08, gpt-image-2.6-sunburst, gpt-image-2.6-flare, or chatgpt-image-latest. Default: gpt-image-2. gpt-image-1 was shut down on October 23, 2026. Use gpt-image-2.5-sunburst or gpt-image-2.5-flare instead. One of the following: string "gpt-image-1" or "gpt-image-1-mini" or "gpt-image-2" or 9 more The image generation model to use. One of gpt-image-1-mini, gpt-image-1.5, gpt-image-2, gpt-image-2-2026-04-21, gpt-image-2.5-sunburst, gpt-image-2.5-sunburst-2026-09-08, gpt-image-2.5-flare, gpt-image-2.5-flare-2026-09-08, gpt-image-2.6-sunburst, gpt-image-2.6-flare, or chatgpt-image-latest. Default: gpt-image-2. gpt-image-1 was shut down on October 23, 2026. Use gpt-image-2.5-sunburst or gpt-image-2.5-flare instead. One of the following: "gpt-image-1-mini" "gpt-image-2" "gpt-image-2-2026-04-21" "gpt-image-2.5-sunburst" "gpt-image-2.5-sunburst-2026-09-08" "gpt-image-2.5-flare" "gpt-image-2.5-flare-2026-09-08" "gpt-image-2.6-sunburst" "gpt-image-2.6-flare" "gpt-image-1.5" "chatgpt-image-latest" "gpt-image-1" Deprecated. GPT Image 1 was shut down on October 23, 2026. Use gpt-image-2.5-sunburst or gpt-image-2.5-flare instead. moderation: optional "auto" or "low" (default: "auto") Moderation level for the generated image. Default: auto. One of the following: "auto" "low" output_compression: optional integer (default: 100) Compression level for the output image. Default: 100. minimum0 maximum100 output_format: optional "png" or "webp" or "jpeg" or 2 more (default: "png") The output format of the generated image. One of png, webp, jpeg, gif, or svg. Default: png. GIF and SVG output require a model that supports the selected format. GIF output does not support partial image streaming (partial_images greater than 0), input_image_mask, or custom output_compression. Responses lifecycle events can still be streamed for GIF output. One of the following: "png" "webp" "jpeg" "gif" "svg" partial_images: optional integer (default: 0) Number of partial images to generate in streaming mode, from 0 (default value) to 3. minimum0 maximum3 quality: optional "low" or "medium" or "high" or 3 more (default: "auto") The quality of the generated image. The GPT image models support low, medium, and high. gpt-image-2.5-sunburst and gpt-image-2.5-flare, including their 2026-09-08 snapshots, also support xhigh and max. Default: auto. One of the following: "low" "medium" "high" "xhigh" "max" "auto" size: optional string or "1024x1024" or "1024x1536" or "1536x1024" or "auto" (default: "auto") The size of the generated images. For gpt-image-2, gpt-image-2-2026-04-21, gpt-image-2.5-sunburst, gpt-image-2.5-sunburst-2026-09-08, gpt-image-2.5-flare, and gpt-image-2.5-flare-2026-09-08, arbitrary resolutions are supported as WIDTHxHEIGHT strings, for example 1536x864. Width and height must both be divisible by 16 and the requested aspect ratio must be between 1:3 and 3:1. Resolutions above 2560x1440 are experimental, and the maximum supported resolution is 3840x2160. The requested size must also satisfy the model’s current pixel and edge limits. The standard sizes 1024x1024, 1536x1024, and 1024x1536 are supported by the GPT image models; auto is supported for models that allow automatic sizing. One of the following: string "1024x1024" or "1024x1536" or "1536x1024" or "auto" The size of the generated images. For gpt-image-2, gpt-image-2-2026-04-21, gpt-image-2.5-sunburst, gpt-image-2.5-sunburst-2026-09-08, gpt-image-2.5-flare, and gpt-image-2.5-flare-2026-09-08, arbitrary resolutions are supported as WIDTHxHEIGHT strings, for example 1536x864. Width and height must both be divisible by 16 and the requested aspect ratio must be between 1:3 and 3:1. Resolutions above 2560x1440 are experimental, and the maximum supported resolution is 3840x2160. The requested size must also satisfy the model’s current pixel and edge limits. The standard sizes 1024x1024, 1536x1024, and 1024x1536 are supported by the GPT image models; auto is supported for models that allow automatic sizing. One of the following: "1024x1024" "1024x1536" "1536x1024" "auto" svg: optional { model, reasoning } SVG author model settings. Requires output_format to be svg. When SVG model selection is enabled, omitting this object uses the outer response model. Otherwise, the default SVG author is used and explicit model overrides are unavailable. model: optional string minLength1 reasoning: optional object or null Reasoning effort for SVG authoring. When omitted, uses the author model’s default in both Images and Responses. effort: optional "none" or "minimal" or "low" or 4 more Controls how much effort the model should spend on reasoning for this request. One of the following: "none" "minimal" "low" "medium" "high" "xhigh" "max" LocalShell { type } A tool that allows the model to execute shell commands in a local environment. type: "local_shell" (default: "local_shell") The type of the local shell tool. Always local_shell. Shell { type, allowed_callers, environment } A tool that allows the model to execute shell commands. type: "shell" (default: "shell") The type of the shell tool. Always shell. allowed_callers: optional array of "direct" or "programmatic" or null The tool invocation context(s). minItems1 One of the following: "direct" "programmatic" environment: optional ContainerAuto or LocalEnvironment or ContainerReference or null One of the following: ContainerAuto { type, file_ids, memory_limit, 2 more } type: "container_auto" (default: "container_auto") Automatically creates a container for this request file_ids: optional array of string An optional list of uploaded files to make available to your code. maxItems50 memory_limit: optional "1g" or "4g" or "16g" or "64g" or null The memory limit for the container. One of the following: "1g" "4g" "16g" "64g" network_policy: optional ContainerNetworkPolicyDisabled or ContainerNetworkPolicyAllowlist Network access policy for the container. One of the following: ContainerNetworkPolicyDisabled { type } type: "disabled" (default: "disabled") Disable outbound network access. Always disabled. ContainerNetworkPolicyAllowlist { allowed_domains, type, domain_secrets } allowed_domains: array of string A list of allowed domains when type is allowlist. minItems1 type: "allowlist" (default: "allowlist") Allow outbound network access only to specified domains. Always allowlist. domain_secrets: optional array of ContainerNetworkPolicyDomainSecret { domain, name, value } Optional domain-scoped secrets for allowlisted domains. minItems1 domain: string The domain associated with the secret. minLength1 name: string The name of the secret to inject for the domain. minLength1 value: string The secret value to inject for the domain. minLength1 maxLength10485760 skills: optional array of SkillReference or InlineSkill An optional list of skills referenced by id or inline data. maxItems200 One of the following: SkillReference { skill_id, type, version } skill_id: string The ID of the referenced skill. minLength1 maxLength64 type: "skill_reference" (default: "skill_reference") References a skill created with the /v1/skills endpoint. version: optional string Optional skill version. Use a positive integer or ‘latest’. Omit for default. InlineSkill { description, name, source, type } description: string The description of the skill. name: string The name of the skill. source: InlineSkillSource { data, media_type, type } Inline skill payload type: "inline" (default: "inline") Defines an inline skill for this request. LocalEnvironment { type, skills } type: "local" (default: "local") Use a local computer environment. skills: optional array of LocalSkill { description, name, path } An optional list of skills. maxItems200 description: string The description of the skill. name: string The name of the skill. path: string The path to the directory containing the skill. ContainerReference { container_id, type } container_id: string The ID of the referenced container. type: "container_reference" (default: "container_reference") References a container created with the /v1/containers endpoint Custom { name, type, allowed_callers, 4 more } A custom tool that processes input using a specified format. Learn more about custom tools name: string The name of the custom tool, used to identify it in tool calls. type: "custom" (default: "custom") The type of the custom tool. Always custom. allowed_callers: optional array of "direct" or "programmatic" or null The tool invocation context(s). minItems1 One of the following: "direct" "programmatic" async: optional boolean Whether the tool response can be returned asynchronously versus immediately returned on next response creation. defer_loading: optional boolean Whether this tool should be deferred and discovered via tool search. description: optional string Optional description of the custom tool, used to provide more context. format: optional CustomToolInputFormat The input format for the custom tool. Default is unconstrained text. Namespace { description, name, tools, type } Groups function/custom tools under a shared namespace. description: string A description of the namespace shown to the model. name: string The namespace name used in tool calls (for example, crm). minLength1 tools: array of Function or Custom The function/custom tools available inside this namespace. minItems1 One of the following: Function { name, type, allowed_callers, 6 more } name: string pattern^[a-zA-Z0-9_-]+$ minLength1 maxLength128 type: "function" (default: "function") allowed_callers: optional array of "direct" or "programmatic" or null The tool invocation context(s). minItems1 One of the following: "direct" "programmatic" async: optional boolean Whether the tool response can be returned asynchronously versus immediately returned on next response creation. defer_loading: optional boolean Whether this function should be deferred and discovered via tool search. description: optional string or null output_schema: optional map[unknown] or null A JSON Schema describing the JSON value encoded in string outputs for this function tool. This does not describe content-array outputs. parameters: optional unknown or null strict: optional boolean or null Whether to enforce strict parameter validation. If omitted, Responses attempts to use strict validation when the schema is compatible, and falls back to non-strict validation otherwise. Custom { name, type, allowed_callers, 4 more } A custom tool that processes input using a specified format. Learn more about custom tools name: string The name of the custom tool, used to identify it in tool calls. type: "custom" (default: "custom") The type of the custom tool. Always custom. allowed_callers: optional array of "direct" or "programmatic" or null The tool invocation context(s). minItems1 One of the following: "direct" "programmatic" async: optional boolean Whether the tool response can be returned asynchronously versus immediately returned on next response creation. defer_loading: optional boolean Whether this tool should be deferred and discovered via tool search. description: optional string Optional description of the custom tool, used to provide more context. format: optional CustomToolInputFormat The input format for the custom tool. Default is unconstrained text. type: "namespace" (default: "namespace") The type of the tool. Always namespace. ToolSearch { type, description, execution, parameters } Hosted or BYOT tool search configuration for deferred tools. type: "tool_search" (default: "tool_search") The type of the tool. Always tool_search. description: optional string or null Description shown to the model for a client-executed tool search tool. execution: optional "server" or "client" Whether tool search is executed by the server or by the client. One of the following: "server" "client" parameters: optional unknown or null Parameter schema for a client-executed tool search tool. WebSearchPreview { type, search_content_types, search_context_size, user_location } This tool searches the web for relevant results to use in a response. Learn more about the web search tool. type: "web_search_preview" or "web_search_preview_2025_03_11" (default: "web_search_preview") The type of the web search tool. One of web_search_preview or web_search_preview_2025_03_11. One of the following: "web_search_preview" "web_search_preview_2025_03_11" search_content_types: optional array of "text" or "image" One of the following: "text" "image" search_context_size: optional "low" or "medium" or "high" High level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default. One of the following: "low" "medium" "high" user_location: optional object or null The approximate location of the user. If omitted or null, defaults to the United States. To avoid this fallback, pass {"type": "approximate"} without location fields. To localize results, provide the relevant location fields. type: "approximate" (default: "approximate") The type of location approximation. Always approximate. city: optional string or null Free text input for the city of the user, e.g. San Francisco. country: optional string or null The two-letter ISO country code of the user, e.g. US. region: optional string or null Free text input for the region of the user, e.g. California. timezone: optional string or null The IANA timezone of the user, e.g. America/Los_Angeles. ApplyPatch { type, allowed_callers } Allows the assistant to create, delete, or update files using unified diffs. type: "apply_patch" (default: "apply_patch") The type of the tool. Always apply_patch. allowed_callers: optional array of "direct" or "programmatic" or null The tool invocation context(s). minItems1 One of the following: "direct" "programmatic" type: "tool_search_output" (default: "tool_search_output") The type of the item. Always tool_search_output. created_by: optional string The identifier of the actor that created the item. AdditionalTools { id, role, tools, type } id: string The unique ID of the additional tools item. role: "unknown" or "user" or "assistant" or 5 more The role that provided the additional tools. One of the following: "unknown" "user" "assistant" "system" "critic" "discriminator" "developer" "tool" tools: array of Function or FileSearch or Computer or 13 more The additional tool definitions made available at this item. One of the following: Function { name, parameters, strict, 6 more } Defines a function in your own code the model can choose to call. Learn more about function calling. name: string The name of the function to call. parameters: map[unknown] or null A JSON schema object describing the parameters of the function. strict: boolean or null Whether strict parameter validation is enforced for this function tool. type: "function" (default: "function") The type of the function tool. Always function. allowed_callers: optional array of "direct" or "programmatic" or null The tool invocation context(s). One of the following: "direct" "programmatic" async: optional boolean defer_loading: optional boolean Whether this function is deferred and loaded via tool search. description: optional string or null A description of the function. Used by the model to determine whether or not to call the function. output_schema: optional map[unknown] or null A JSON schema object describing the JSON value encoded in string outputs for this function. FileSearch { type, vector_store_ids, filters, 2 more } A tool that searches for relevant content from uploaded files. Learn more about the file search tool. type: "file_search" (default: "file_search") The type of the file search tool. Always file_search. vector_store_ids: array of string The IDs of the vector stores to search. filters: optional ComparisonFilter or CompoundFilter or null A filter to apply. One of the following: ComparisonFilter { key, type, value } A filter used to compare a specified attribute key to a given value using a defined comparison operation. key: string The key to compare against the value. type: "eq" or "ne" or "gt" or 5 more (default: "eq") Specifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin. eq: equals ne: not equal gt: greater than gte: greater than or equal lt: less than lte: less than or equal in: in nin: not in One of the following: "eq" "ne" "gt" "gte" "lt" "lte" "in" "nin" value: string or number or boolean or array of string or number The value to compare against the attribute key; supports string, number, or boolean types. One of the following: string number boolean array of string or number One of the following: string number CompoundFilter { filters, type } Combine multiple filters using and or or. filters: array of ComparisonFilter or CompoundFilter Array of filters to combine. Items can be ComparisonFilter or CompoundFilter. One of the following: ComparisonFilter { key, type, value } A filter used to compare a specified attribute key to a given value using a defined comparison operation. key: string The key to compare against the value. type: "eq" or "ne" or "gt" or 5 more (default: "eq") Specifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin. eq: equals ne: not equal gt: greater than gte: greater than or equal lt: less than lte: less than or equal in: in nin: not in One of the following: "eq" "ne" "gt" "gte" "lt" "lte" "in" "nin" value: string or number or boolean or array of string or number The value to compare against the attribute key; supports string, number, or boolean types. One of the following: string number boolean array of string or number One of the following: string number CompoundFilter { filters, type } This type repeats the enclosing schema. type: "and" or "or" Type of operation: and or or. One of the following: "and" "or" max_num_results: optional integer The maximum number of results to return. This number should be between 1 and 50 inclusive. ranking_options: optional { hybrid_search, ranker, score_threshold } Ranking options for search. hybrid_search: optional { embedding_weight, text_weight } Weights that control how reciprocal rank fusion balances semantic embedding matches versus sparse keyword matches when hybrid search is enabled. embedding_weight: number The weight of the embedding in the reciprocal ranking fusion. text_weight: number The weight of the text in the reciprocal ranking fusion. ranker: optional "auto" or "default-2024-11-15" The ranker to use for the file search. One of the following: "auto" "default-2024-11-15" score_threshold: optional number The score threshold for the file search, a number between 0 and 1. Numbers closer to 1 will attempt to return only the most relevant results, but may return fewer results. Computer { type } A tool that controls a virtual computer. Learn more about the computer tool. type: "computer" (default: "computer") The type of the computer tool. Always computer. ComputerUsePreview { display_height, display_width, environment, type } A tool that controls a virtual computer. Learn more about the computer tool. display_height: integer The height of the computer display. display_width: integer The width of the computer display. environment: "windows" or "mac" or "linux" or 2 more The type of computer environment to control. One of the following: "windows" "mac" "linux" "ubuntu" "browser" type: "computer_use_preview" (default: "computer_use_preview") The type of the computer use tool. Always computer_use_preview. WebSearch { type, external_web_access, filters, 2 more } Search the Internet for sources related to the prompt. Learn more about the web search tool. type: "web_search" or "web_search_2025_08_26" (default: "web_search") The type of the web search tool. One of web_search or web_search_2025_08_26. One of the following: "web_search" "web_search_2025_08_26" external_web_access: optional boolean (default: true) Allow live internet access for web search. Defaults to true when omitted. When false, the web search tool runs in offline/cache-only mode and will not fetch new external content. filters: optional object or null Filters for the search. allowed_domains: optional array of string or null (default: []) Allowed domains for the search. If not provided, all domains are allowed. Subdomains of the provided domains are allowed as well. Example: ["pubmed.ncbi.nlm.nih.gov"] search_context_size: optional "low" or "medium" or "high" (default: "medium") High level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default. One of the following: "low" "medium" "high" user_location: optional object or null The approximate location of the user. If omitted or null, defaults to the United States. To avoid this fallback, pass {"type": "approximate"} without location fields. To localize results, provide the relevant location fields. city: optional string or null Free text input for the city of the user, e.g. San Francisco. country: optional string or null The two-letter ISO country code of the user, e.g. US. region: optional string or null Free text input for the region of the user, e.g. California. timezone: optional string or null The IANA timezone of the user, e.g. America/Los_Angeles. type: optional "approximate" (default: "approximate") The type of location approximation. Always approximate. Mcp { server_label, type, allowed_callers, 9 more } Give the model access to additional tools via remote Model Context Protocol (MCP) servers. Learn more about MCP. server_label: string A label for this MCP server, used to identify it in tool calls. type: "mcp" The type of the MCP tool. Always mcp. allowed_callers: optional array of "direct" or "programmatic" or null The tool invocation context(s). minItems1 One of the following: "direct" "programmatic" allowed_tools: optional array of string or McpToolFilter or null List of allowed tool names or a filter object. One of the following: McpAllowedTools = array of string A string array of allowed tool names McpToolFilter { read_only, tool_names } A filter object to specify which tools are allowed. read_only: optional boolean Indicates whether or not a tool modifies data or is read-only. If an MCP server is annotated with readOnlyHint, it will match this filter. tool_names: optional array of string List of allowed tool names. authorization: optional string An OAuth access token that can be used with a remote MCP server, either with a custom MCP server URL or a service connector. Your application must handle the OAuth authorization flow and provide the token here. connector_id: optional "connector_dropbox" or "connector_gmail" or "connector_googlecalendar" or 5 more Deprecated. Identifier for service connectors, like those available in ChatGPT. One of server_url, connector_id, or tunnel_id must be provided. Learn more about service connectors here. This field is deprecated for models released after September 1, 2026. Use server_url to connect to a remote MCP server, or tunnel_id to connect through a Secure MCP Tunnel. Currently supported connector_id values are: Dropbox: connector_dropbox Gmail: connector_gmail Google Calendar: connector_googlecalendar Google Drive: connector_googledrive Microsoft Teams: connector_microsoftteams Outlook Calendar: connector_outlookcalendar Outlook Email: connector_outlookemail SharePoint: connector_sharepoint One of the following: "connector_dropbox" "connector_gmail" "connector_googlecalendar" "connector_googledrive" "connector_microsoftteams" "connector_outlookcalendar" "connector_outlookemail" "connector_sharepoint" defer_loading: optional boolean Whether this MCP tool is deferred and discovered via tool search. headers: optional map[string] or null Optional HTTP headers to send to the MCP server. Use for authentication or other purposes. require_approval: optional McpToolApprovalFilter or "always" or "never" or null (default: "always") Specify which of the MCP server’s tools require approval. One of the following: McpToolApprovalFilter { always, never } Specify which of the MCP server’s tools require approval. Can be always, never, or a filter object associated with tools that require approval. always: optional { read_only, tool_names } A filter object to specify which tools are allowed. read_only: optional boolean Indicates whether or not a tool modifies data or is read-only. If an MCP server is annotated with readOnlyHint, it will match this filter. tool_names: optional array of string List of allowed tool names. never: optional { read_only, tool_names } A filter object to specify which tools are allowed. read_only: optional boolean Indicates whether or not a tool modifies data or is read-only. If an MCP server is annotated with readOnlyHint, it will match this filter. tool_names: optional array of string List of allowed tool names. McpToolApprovalSetting = "always" or "never" Specify a single approval policy for all tools. One of always or never. When set to always, all tools will require approval. When set to never, all tools will not require approval. One of the following: "always" "never" server_description: optional string Optional description of the MCP server, used to provide more context. server_url: optional string The URL for the MCP server. One of server_url, connector_id, or tunnel_id must be provided. formaturi tunnel_id: optional string The Secure MCP Tunnel ID to use instead of a direct server URL. One of server_url, connector_id, or tunnel_id must be provided. pattern^tunnel_[a-z0-9]{32}$ CodeInterpreter { container, type, allowed_callers } A tool that runs Python code to help generate a response to a prompt. container: string or CodeInterpreterToolAuto The code interpreter container. Can be a container ID or an object that specifies uploaded file IDs to make available to your code, along with an optional memory_limit setting. One of the following: string The container ID. CodeInterpreterToolAuto { type, file_ids, memory_limit, network_policy } Configuration for a code interpreter container. Optionally specify the IDs of the files to run the code on. type: "auto" (default: "auto") Always auto. file_ids: optional array of string An optional list of uploaded files to make available to your code. maxItems50 memory_limit: optional "1g" or "4g" or "16g" or "64g" or null The memory limit for the code interpreter container. One of the following: "1g" "4g" "16g" "64g" network_policy: optional ContainerNetworkPolicyDisabled or ContainerNetworkPolicyAllowlist Network access policy for the container. One of the following: ContainerNetworkPolicyDisabled { type } type: "disabled" (default: "disabled") Disable outbound network access. Always disabled. ContainerNetworkPolicyAllowlist { allowed_domains, type, domain_secrets } allowed_domains: array of string A list of allowed domains when type is allowlist. minItems1 type: "allowlist" (default: "allowlist") Allow outbound network access only to specified domains. Always allowlist. domain_secrets: optional array of ContainerNetworkPolicyDomainSecret { domain, name, value } Optional domain-scoped secrets for allowlisted domains. minItems1 domain: string The domain associated with the secret. minLength1 name: string The name of the secret to inject for the domain. minLength1 value: string The secret value to inject for the domain. minLength1 maxLength10485760 type: "code_interpreter" The type of the code interpreter tool. Always code_interpreter. allowed_callers: optional array of "direct" or "programmatic" or null The tool invocation context(s). minItems1 One of the following: "direct" "programmatic" ProgrammaticToolCalling { type } type: "programmatic_tool_calling" (default: "programmatic_tool_calling") The type of the tool. Always programmatic_tool_calling. ImageGeneration { type, action, background, 13 more } A tool that generates images using the GPT image models. type: "image_generation" The type of the image generation tool. Always image_generation. action: optional "generate" or "edit" or "auto" Whether to generate a new image or edit an existing image. Default: auto. One of the following: "generate" "edit" "auto" background: optional "transparent" or "opaque" or "auto" (default: "auto") Set the background of the generated image. One of transparent, opaque, or auto. gpt-image-2.5-sunburst and gpt-image-2.5-flare, including their 2026-09-08 snapshots, support opaque and transparent backgrounds. Transparent backgrounds are available for supported GPT Image models. For gpt-image-2 and gpt-image-2-2026-04-21, this support is in preview. When using transparent, set the output format to png or webp. Default: auto. One of the following: "transparent" "opaque" "auto" complexity: optional "low" or "medium" or "high" Computation spent planning the image, independently of rendering quality. Overrides the outer response’s reasoning.effort for image generation. When omitted, inherits a supported outer reasoning effort or uses the image model’s configured default. For SVG output, controls the reference image, not the SVG author’s reasoning. One of the following: "low" "medium" "high" frame_count: optional integer (default: 9) Number of GIF frames. Requires output_format to be gif. Default: 9. minimum2 maximum16 frame_duration_ms: optional integer (default: 200) Duration of each GIF frame in milliseconds, rounded to 10 ms. Requires output_format to be gif. Default: 200. minimum20 maximum2000 input_fidelity: optional "high" or "low" or null Control how much effort the model will exert to match the style and features, especially facial features, of input images. Supports high and low on gpt-image-1.5; gpt-image-1-mini supports only low. For gpt-image-2, omit this parameter. Defaults to low on supported models. One of the following: "high" "low" input_image_mask: optional { file_id, image_url } Optional mask for inpainting. Contains image_url (string, optional) and file_id (string, optional). file_id: optional string File ID for the mask image. image_url: optional string Base64-encoded mask image. model: optional string or "gpt-image-1" or "gpt-image-1-mini" or "gpt-image-2" or 9 more The image generation model to use. One of gpt-image-1-mini, gpt-image-1.5, gpt-image-2, gpt-image-2-2026-04-21, gpt-image-2.5-sunburst, gpt-image-2.5-sunburst-2026-09-08, gpt-image-2.5-flare, gpt-image-2.5-flare-2026-09-08, gpt-image-2.6-sunburst, gpt-image-2.6-flare, or chatgpt-image-latest. Default: gpt-image-2. gpt-image-1 was shut down on October 23, 2026. Use gpt-image-2.5-sunburst or gpt-image-2.5-flare instead. One of the following: string "gpt-image-1" or "gpt-image-1-mini" or "gpt-image-2" or 9 more The image generation model to use. One of gpt-image-1-mini, gpt-image-1.5, gpt-image-2, gpt-image-2-2026-04-21, gpt-image-2.5-sunburst, gpt-image-2.5-sunburst-2026-09-08, gpt-image-2.5-flare, gpt-image-2.5-flare-2026-09-08, gpt-image-2.6-sunburst, gpt-image-2.6-flare, or chatgpt-image-latest. Default: gpt-image-2. gpt-image-1 was shut down on October 23, 2026. Use gpt-image-2.5-sunburst or gpt-image-2.5-flare instead. One of the following: "gpt-image-1-mini" "gpt-image-2" "gpt-image-2-2026-04-21" "gpt-image-2.5-sunburst" "gpt-image-2.5-sunburst-2026-09-08" "gpt-image-2.5-flare" "gpt-image-2.5-flare-2026-09-08" "gpt-image-2.6-sunburst" "gpt-image-2.6-flare" "gpt-image-1.5" "chatgpt-image-latest" "gpt-image-1" Deprecated. GPT Image 1 was shut down on October 23, 2026. Use gpt-image-2.5-sunburst or gpt-image-2.5-flare instead. moderation: optional "auto" or "low" (default: "auto") Moderation level for the generated image. Default: auto. One of the following: "auto" "low" output_compression: optional integer (default: 100) Compression level for the output image. Default: 100. minimum0 maximum100 output_format: optional "png" or "webp" or "jpeg" or 2 more (default: "png") The output format of the generated image. One of png, webp, jpeg, gif, or svg. Default: png. GIF and SVG output require a model that supports the selected format. GIF output does not support partial image streaming (partial_images greater than 0), input_image_mask, or custom output_compression. Responses lifecycle events can still be streamed for GIF output. One of the following: "png" "webp" "jpeg" "gif" "svg" partial_images: optional integer (default: 0) Number of partial images to generate in streaming mode, from 0 (default value) to 3. minimum0 maximum3 quality: optional "low" or "medium" or "high" or 3 more (default: "auto") The quality of the generated image. The GPT image models support low, medium, and high. gpt-image-2.5-sunburst and gpt-image-2.5-flare, including their 2026-09-08 snapshots, also support xhigh and max. Default: auto. One of the following: "low" "medium" "high" "xhigh" "max" "auto" size: optional string or "1024x1024" or "1024x1536" or "1536x1024" or "auto" (default: "auto") The size of the generated images. For gpt-image-2, gpt-image-2-2026-04-21, gpt-image-2.5-sunburst, gpt-image-2.5-sunburst-2026-09-08, gpt-image-2.5-flare, and gpt-image-2.5-flare-2026-09-08, arbitrary resolutions are supported as WIDTHxHEIGHT strings, for example 1536x864. Width and height must both be divisible by 16 and the requested aspect ratio must be between 1:3 and 3:1. Resolutions above 2560x1440 are experimental, and the maximum supported resolution is 3840x2160. The requested size must also satisfy the model’s current pixel and edge limits. The standard sizes 1024x1024, 1536x1024, and 1024x1536 are supported by the GPT image models; auto is supported for models that allow automatic sizing. One of the following: string "1024x1024" or "1024x1536" or "1536x1024" or "auto" The size of the generated images. For gpt-image-2, gpt-image-2-2026-04-21, gpt-image-2.5-sunburst, gpt-image-2.5-sunburst-2026-09-08, gpt-image-2.5-flare, and gpt-image-2.5-flare-2026-09-08, arbitrary resolutions are supported as WIDTHxHEIGHT strings, for example 1536x864. Width and height must both be divisible by 16 and the requested aspect ratio must be between 1:3 and 3:1. Resolutions above 2560x1440 are experimental, and the maximum supported resolution is 3840x2160. The requested size must also satisfy the model’s current pixel and edge limits. The standard sizes 1024x1024, 1536x1024, and 1024x1536 are supported by the GPT image models; auto is supported for models that allow automatic sizing. One of the following: "1024x1024" "1024x1536" "1536x1024" "auto" svg: optional { model, reasoning } SVG author model settings. Requires output_format to be svg. When SVG model selection is enabled, omitting this object uses the outer response model. Otherwise, the default SVG author is used and explicit model overrides are unavailable. model: optional string minLength1 reasoning: optional object or null Reasoning effort for SVG authoring. When omitted, uses the author model’s default in both Images and Responses. effort: optional "none" or "minimal" or "low" or 4 more Controls how much effort the model should spend on reasoning for this request. One of the following: "none" "minimal" "low" "medium" "high" "xhigh" "max" LocalShell { type } A tool that allows the model to execute shell commands in a local environment. type: "local_shell" (default: "local_shell") The type of the local shell tool. Always local_shell. Shell { type, allowed_callers, environment } A tool that allows the model to execute shell commands. type: "shell" (default: "shell") The type of the shell tool. Always shell. allowed_callers: optional array of "direct" or "programmatic" or null The tool invocation context(s). minItems1 One of the following: "direct" "programmatic" environment: optional ContainerAuto or LocalEnvironment or ContainerReference or null One of the following: ContainerAuto { type, file_ids, memory_limit, 2 more } type: "container_auto" (default: "container_auto") Automatically creates a container for this request file_ids: optional array of string An optional list of uploaded files to make available to your code. maxItems50 memory_limit: optional "1g" or "4g" or "16g" or "64g" or null The memory limit for the container. One of the following: "1g" "4g" "16g" "64g" network_policy: optional ContainerNetworkPolicyDisabled or ContainerNetworkPolicyAllowlist Network access policy for the container. One of the following: ContainerNetworkPolicyDisabled { type } type: "disabled" (default: "disabled") Disable outbound network access. Always disabled. ContainerNetworkPolicyAllowlist { allowed_domains, type, domain_secrets } allowed_domains: array of string A list of allowed domains when type is allowlist. minItems1 type: "allowlist" (default: "allowlist") Allow outbound network access only to specified domains. Always allowlist. domain_secrets: optional array of ContainerNetworkPolicyDomainSecret { domain, name, value } Optional domain-scoped secrets for allowlisted domains. minItems1 domain: string The domain associated with the secret. minLength1 name: string The name of the secret to inject for the domain. minLength1 value: string The secret value to inject for the domain. minLength1 maxLength10485760 skills: optional array of SkillReference or InlineSkill An optional list of skills referenced by id or inline data. maxItems200 One of the following: SkillReference { skill_id, type, version } skill_id: string The ID of the referenced skill. minLength1 maxLength64 type: "skill_reference" (default: "skill_reference") References a skill created with the /v1/skills endpoint. version: optional string Optional skill version. Use a positive integer or ‘latest’. Omit for default. InlineSkill { description, name, source, type } description: string The description of the skill. name: string The name of the skill. source: InlineSkillSource { data, media_type, type } Inline skill payload type: "inline" (default: "inline") Defines an inline skill for this request. LocalEnvironment { type, skills } type: "local" (default: "local") Use a local computer environment. skills: optional array of LocalSkill { description, name, path } An optional list of skills. maxItems200 description: string The description of the skill. name: string The name of the skill. path: string The path to the directory containing the skill. ContainerReference { container_id, type } container_id: string The ID of the referenced container. type: "container_reference" (default: "container_reference") References a container created with the /v1/containers endpoint Custom { name, type, allowed_callers, 4 more } A custom tool that processes input using a specified format. Learn more about custom tools name: string The name of the custom tool, used to identify it in tool calls. type: "custom" (default: "custom") The type of the custom tool. Always custom. allowed_callers: optional array of "direct" or "programmatic" or null The tool invocation context(s). minItems1 One of the following: "direct" "programmatic" async: optional boolean Whether the tool response can be returned asynchronously versus immediately returned on next response creation. defer_loading: optional boolean Whether this tool should be deferred and discovered via tool search. description: optional string Optional description of the custom tool, used to provide more context. format: optional CustomToolInputFormat The input format for the custom tool. Default is unconstrained text. Namespace { description, name, tools, type } Groups function/custom tools under a shared namespace. description: string A description of the namespace shown to the model. name: string The namespace name used in tool calls (for example, crm). minLength1 tools: array of Function or Custom The function/custom tools available inside this namespace. minItems1 One of the following: Function { name, type, allowed_callers, 6 more } name: string pattern^[a-zA-Z0-9_-]+$ minLength1 maxLength128 type: "function" (default: "function") allowed_callers: optional array of "direct" or "programmatic" or null The tool invocation context(s). minItems1 One of the following: "direct" "programmatic" async: optional boolean Whether the tool response can be returned asynchronously versus immediately returned on next response creation. defer_loading: optional boolean Whether this function should be deferred and discovered via tool search. description: optional string or null output_schema: optional map[unknown] or null A JSON Schema describing the JSON value encoded in string outputs for this function tool. This does not describe content-array outputs. parameters: optional unknown or null strict: optional boolean or null Whether to enforce strict parameter validation. If omitted, Responses attempts to use strict validation when the schema is compatible, and falls back to non-strict validation otherwise. Custom { name, type, allowed_callers, 4 more } A custom tool that processes input using a specified format. Learn more about custom tools name: string The name of the custom tool, used to identify it in tool calls. type: "custom" (default: "custom") The type of the custom tool. Always custom. allowed_callers: optional array of "direct" or "programmatic" or null The tool invocation context(s). minItems1 One of the following: "direct" "programmatic" async: optional boolean Whether the tool response can be returned asynchronously versus immediately returned on next response creation. defer_loading: optional boolean Whether this tool should be deferred and discovered via tool search. description: optional string Optional description of the custom tool, used to provide more context. format: optional CustomToolInputFormat The input format for the custom tool. Default is unconstrained text. type: "namespace" (default: "namespace") The type of the tool. Always namespace. ToolSearch { type, description, execution, parameters } Hosted or BYOT tool search configuration for deferred tools. type: "tool_search" (default: "tool_search") The type of the tool. Always tool_search. description: optional string or null Description shown to the model for a client-executed tool search tool. execution: optional "server" or "client" Whether tool search is executed by the server or by the client. One of the following: "server" "client" parameters: optional unknown or null Parameter schema for a client-executed tool search tool. WebSearchPreview { type, search_content_types, search_context_size, user_location } This tool searches the web for relevant results to use in a response. Learn more about the web search tool. type: "web_search_preview" or "web_search_preview_2025_03_11" (default: "web_search_preview") The type of the web search tool. One of web_search_preview or web_search_preview_2025_03_11. One of the following: "web_search_preview" "web_search_preview_2025_03_11" search_content_types: optional array of "text" or "image" One of the following: "text" "image" search_context_size: optional "low" or "medium" or "high" High level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default. One of the following: "low" "medium" "high" user_location: optional object or null The approximate location of the user. If omitted or null, defaults to the United States. To avoid this fallback, pass {"type": "approximate"} without location fields. To localize results, provide the relevant location fields. type: "approximate" (default: "approximate") The type of location approximation. Always approximate. city: optional string or null Free text input for the city of the user, e.g. San Francisco. country: optional string or null The two-letter ISO country code of the user, e.g. US. region: optional string or null Free text input for the region of the user, e.g. California. timezone: optional string or null The IANA timezone of the user, e.g. America/Los_Angeles. ApplyPatch { type, allowed_callers } Allows the assistant to create, delete, or update files using unified diffs. type: "apply_patch" (default: "apply_patch") The type of the tool. Always apply_patch. allowed_callers: optional array of "direct" or "programmatic" or null The tool invocation context(s). minItems1 One of the following: "direct" "programmatic" type: "additional_tools" (default: "additional_tools") The type of the item. Always additional_tools. ConfigurationUpdate { id, type, reasoning, text } A configuration update for subsequent responses. Each setting stays in effect until a later update replaces that setting. id: string The unique ID of the configuration update item. type: "configuration_update" (default: "configuration_update") The item type. Always configuration_update. reasoning: optional { effort } The reasoning configuration applied by this update. effort: optional ReasoningEffort or null (default: "medium") The reasoning effort used for subsequent responses until another configuration update replaces it. text: optional { format } The text output configuration for subsequent responses. format: ResponseFormatText or ResponseFormatTextJSONSchemaConfig Use a JSON schema for structured output or text to return to plain text. One of the following: ResponseFormatText { type } Default response format. Used to generate text responses. type: "text" The type of response format being defined. Always text. ResponseFormatTextJSONSchemaConfig { name, schema, type, 2 more } JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs. name: string The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64. schema: map[unknown] The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here. type: "json_schema" The type of response format being defined. Always json_schema. description: optional string A description of what the response format is for, used by the model to determine how to respond in the format. strict: optional boolean or null (default: false) Whether to enable strict schema adherence when generating the output. If set to true, the model will always follow the exact schema defined in the schema field. Only a subset of JSON Schema is supported when strict is true. To learn more, read the Structured Outputs guide. Reasoning { id, summary, type, 3 more } A description of the chain of thought used by a reasoning model while generating a response. Be sure to include these items in your input to the Responses API for subsequent turns of a conversation if you are manually managing context. id: string The unique identifier of the reasoning content. summary: array of SummaryTextContent { text, type } Reasoning summary content. text: string A summary of the reasoning output from the model so far. type: "summary_text" (default: "summary_text") The type of the object. Always summary_text. type: "reasoning" The type of the object. Always reasoning. content: optional array of { text, type } Reasoning text content. text: string The reasoning text from the model. type: "reasoning_text" (default: "reasoning_text") The type of the reasoning text. Always reasoning_text. encrypted_content: optional string or null The encrypted content of the reasoning item. This is populated by default for reasoning items returned by POST /v1/responses and WebSocket response.create requests. When streaming, use the completed reasoning item and its encrypted_content from the response.output_item.done event in subsequent requests. The encrypted_content in response.output_item.added may be incomplete. This is especially important when store is false or when using Zero Data Retention. status: optional "in_progress" or "completed" or "incomplete" The status of the item. One of in_progress, completed, or incomplete. Populated when items are returned via API. One of the following: "in_progress" "completed" "incomplete" Program { id, call_id, code, 2 more } id: string The unique ID of the program item. call_id: string The stable call ID of the program item. code: string The JavaScript source executed by programmatic tool calling. fingerprint: string Opaque program replay fingerprint that must be round-tripped. type: "program" (default: "program") The type of the item. Always program. ProgramOutput { id, call_id, result, 2 more } id: string The unique ID of the program output item. call_id: string The call ID of the program item. result: string The result produced by the program item. status: "completed" or "incomplete" The terminal status of the program output item. One of the following: "completed" "incomplete" type: "program_output" (default: "program_output") The type of the item. Always program_output. Compaction { id, encrypted_content, type, created_by } A compaction item generated by the v1/responses/compact API. id: string The unique ID of the compaction item. encrypted_content: string The encrypted content that was produced by compaction. type: "compaction" (default: "compaction") The type of the item. Always compaction. created_by: optional string The identifier of the actor that created the item. CodeInterpreterCall { id, code, container_id, 3 more } A tool call to run code. id: string The unique ID of the code interpreter tool call. code: string or null The code to run, or null if not available. container_id: string The ID of the container used to run the code. outputs: array of Logs or Image or null The outputs generated by the code interpreter, such as logs or images. Can be null if no outputs are available. One of the following: Logs { logs, type } The logs output from the code interpreter. logs: string The logs output from the code interpreter. type: "logs" (default: "logs") The type of the output. Always logs. Image { type, url } The image output from the code interpreter. type: "image" (default: "image") The type of the output. Always image. url: string The URL of the image output from the code interpreter. formaturi status: "in_progress" or "completed" or "incomplete" or 2 more The status of the code interpreter tool call. Valid values are in_progress, completed, incomplete, interpreting, and failed. One of the following: "in_progress" "completed" "incomplete" "interpreting" "failed" type: "code_interpreter_call" (default: "code_interpreter_call") The type of the code interpreter tool call. Always code_interpreter_call. LocalShellCall { id, action, call_id, 2 more } A tool call to run a command on the local shell. id: string The unique ID of the local shell call. action: { command, env, type, 3 more } Execute a shell command on the server. command: array of string The command to run. env: map[string] Environment variables to set for the command. type: "exec" (default: "exec") The type of the local shell action. Always exec. timeout_ms: optional integer or null Optional timeout in milliseconds for the command. user: optional string or null Optional user to run the command as. working_directory: optional string or null Optional working directory to run the command in. call_id: string The unique ID of the local shell tool call generated by the model. status: "in_progress" or "completed" or "incomplete" The status of the local shell call. One of the following: "in_progress" "completed" "incomplete" type: "local_shell_call" The type of the local shell call. Always local_shell_call. LocalShellCallOutput { id, output, type, status } The output of a local shell tool call. id: string The unique ID of the local shell tool call generated by the model. output: string A JSON string of the output of the local shell tool call. type: "local_shell_call_output" The type of the local shell tool call output. Always local_shell_call_output. status: optional "in_progress" or "completed" or "incomplete" or null The status of the item. One of in_progress, completed, or incomplete. One of the following: "in_progress" "completed" "incomplete" ShellCall { id, action, call_id, 5 more } A tool call that executes one or more shell commands in a managed environment. id: string The unique ID of the shell tool call. Populated when this item is returned via API. action: { commands, max_output_length, timeout_ms } The shell commands and limits that describe how to run the tool call. commands: array of string max_output_length: integer or null Optional maximum number of characters to return from each command. timeout_ms: integer or null Optional timeout in milliseconds for the commands. call_id: string The unique ID of the shell tool call generated by the model. environment: ResponseLocalEnvironment or ResponseContainerReference or null Represents the use of a local environment to perform shell actions. One of the following: ResponseLocalEnvironment { type } Represents the use of a local environment to perform shell actions. type: "local" (default: "local") The environment type. Always local. ResponseContainerReference { container_id, type } Represents a container created with /v1/containers. container_id: string type: "container_reference" (default: "container_reference") The environment type. Always container_reference. status: "in_progress" or "completed" or "incomplete" The status of the shell call. One of in_progress, completed, or incomplete. One of the following: "in_progress" "completed" "incomplete" type: "shell_call" (default: "shell_call") The type of the item. Always shell_call. caller: optional Direct or Program or null The execution context that produced this tool call. One of the following: Direct { type } type: "direct" (default: "direct") Program { caller_id, type } caller_id: string The call ID of the program item that produced this tool call. type: "program" (default: "program") created_by: optional string The ID of the entity that created this tool call. ShellCallOutput { id, call_id, max_output_length, 5 more } The output of a shell tool call that was emitted. id: string The unique ID of the shell call output. Populated when this item is returned via API. call_id: string The unique ID of the shell tool call generated by the model. max_output_length: integer or null The maximum length of the shell command output. This is generated by the model and should be passed back with the raw output. output: array of { outcome, stderr, stdout, created_by } An array of shell call output contents outcome: Timeout or Exit Represents either an exit outcome (with an exit code) or a timeout outcome for a shell call output chunk. One of the following: Timeout { type } Indicates that the shell call exceeded its configured time limit. type: "timeout" (default: "timeout") The outcome type. Always timeout. Exit { exit_code, type } Indicates that the shell commands finished and returned an exit code. exit_code: integer Exit code from the shell process. type: "exit" (default: "exit") The outcome type. Always exit. stderr: string The standard error output that was captured. stdout: string The standard output that was captured. created_by: optional string The identifier of the actor that created the item. status: "in_progress" or "completed" or "incomplete" The status of the shell call output. One of in_progress, completed, or incomplete. One of the following: "in_progress" "completed" "incomplete" type: "shell_call_output" (default: "shell_call_output") The type of the shell call output. Always shell_call_output. caller: optional Direct or Program or null The execution context that produced this tool call. One of the following: Direct { type } type: "direct" (default: "direct") Program { caller_id, type } caller_id: string The call ID of the program item that produced this tool call. type: "program" (default: "program") created_by: optional string The identifier of the actor that created the item. ApplyPatchCall { id, call_id, operation, 4 more } A tool call that applies file diffs by creating, deleting, or updating files. id: string The unique ID of the apply patch tool call. Populated when this item is returned via API. call_id: string The unique ID of the apply patch tool call generated by the model. operation: CreateFile or DeleteFile or UpdateFile One of the create_file, delete_file, or update_file operations applied via apply_patch. One of the following: CreateFile { diff, path, type } Instruction describing how to create a file via the apply_patch tool. diff: string Diff to apply. path: string Path of the file to create. type: "create_file" (default: "create_file") Create a new file with the provided diff. DeleteFile { path, type } Instruction describing how to delete a file via the apply_patch tool. path: string Path of the file to delete. type: "delete_file" (default: "delete_file") Delete the specified file. UpdateFile { diff, path, type } Instruction describing how to update a file via the apply_patch tool. diff: string Diff to apply. path: string Path of the file to update. type: "update_file" (default: "update_file") Update an existing file with the provided diff. status: "in_progress" or "completed" The status of the apply patch tool call. One of in_progress or completed. One of the following: "in_progress" "completed" type: "apply_patch_call" (default: "apply_patch_call") The type of the item. Always apply_patch_call. caller: optional Direct or Program or null The execution context that produced this tool call. One of the following: Direct { type } type: "direct" (default: "direct") Program { caller_id, type } caller_id: string The call ID of the program item that produced this tool call. type: "program" (default: "program") created_by: optional string The ID of the entity that created this tool call. ApplyPatchCallOutput { id, call_id, status, 4 more } The output emitted by an apply patch tool call. id: string The unique ID of the apply patch tool call output. Populated when this item is returned via API. call_id: string The unique ID of the apply patch tool call generated by the model. status: "completed" or "failed" The status of the apply patch tool call output. One of completed or failed. One of the following: "completed" "failed" type: "apply_patch_call_output" (default: "apply_patch_call_output") The type of the item. Always apply_patch_call_output. caller: optional Direct or Program or null The execution context that produced this tool call. One of the following: Direct { type } type: "direct" (default: "direct") Program { caller_id, type } caller_id: string The call ID of the program item that produced this tool call. type: "program" (default: "program") created_by: optional string The ID of the entity that created this tool call output. output: optional string or null Optional textual output returned by the apply patch tool. McpListTools { id, server_label, tools, 2 more } A list of tools available on an MCP server. id: string The unique ID of the list. server_label: string The label of the MCP server. tools: array of { input_schema, name, annotations, description } The tools available on the server. input_schema: unknown The JSON schema describing the tool’s input. name: string The name of the tool. annotations: optional unknown or null Additional annotations about the tool. description: optional string or null The description of the tool. type: "mcp_list_tools" The type of the item. Always mcp_list_tools. error: optional string or null Error message if the server could not list tools. McpApprovalRequest { id, arguments, name, 2 more } A request for human approval of a tool invocation. id: string The unique ID of the approval request. arguments: string A JSON string of arguments for the tool. name: string The name of the tool to run. server_label: string The label of the MCP server making the request. type: "mcp_approval_request" The type of the item. Always mcp_approval_request. McpApprovalResponse { id, approval_request_id, approve, 2 more } A response to an MCP approval request. id: string The unique ID of the approval response approval_request_id: string The ID of the approval request being answered. approve: boolean Whether the request was approved. type: "mcp_approval_response" The type of the item. Always mcp_approval_response. reason: optional string or null Optional reason for the decision. McpCall { id, arguments, name, 6 more } An invocation of a tool on an MCP server. id: string The unique ID of the tool call. arguments: string A JSON string of the arguments passed to the tool. name: string The name of the tool that was run. server_label: string The label of the MCP se
[...]
